#include <zasm/stream.h>
#include <zasm/feeder.h>
#include <zasm/list.h>
#include <zasm/tokens.h>
#include <zasm/parser.h>
#include <zasm/assembler.h>
#include <zasm/string.h>
#include <zasm/functions.h>
#include <string.h>

static struct assembler_t *asmb;
static struct stream_t *output;

static inline struct token_t opcode_p(struct feeder_t *input, struct token_t *token, struct processor_t *codes);
static inline struct token_t end_of_line_p(struct feeder_t *input, struct token_t *token);


static inline struct token_t pc_parser_0(struct feeder_t *input, struct token_t *token,int type1,int type2,int type3,int type4,int type5,int type6,int type7,int type8,int type9,int type10,int type11,int type12,int type13,int type14,int type15,int type16,int type17,int type18,int type19,int type20,int type21,int type22,int type23,int type24,int type25,int type26,int type27,int type28,int type29,int type30,int type31,int type32)
{
  struct token_t result;
  if ((token->type == type1)||(token->type == type2)||(token->type == type3)||(token->type == type4)||(token->type == type5)||(token->type == type6)||(token->type == type7)||(token->type == type8)||(token->type == type9)||(token->type == type10)||(token->type == type11)||(token->type == type12)||(token->type == type13)||(token->type == type14)||(token->type == type15)||(token->type == type16)||(token->type == type17)||(token->type == type18)||(token->type == type19)||(token->type == type20)||(token->type == type21)||(token->type == type22)||(token->type == type23)||(token->type == type24)||(token->type == type25)||(token->type == type26)||(token->type == type27)||(token->type == type28)||(token->type == type29)||(token->type == type30)||(token->type == type31)||(token->type == type32))
  {
    result = *token;
    *token = feeder_get(input);
  }
  else
    result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_1(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  struct list_t *list;
  list = list_new();
  while (1)
  {
    result = pc_parser_0(input,token,TOK_SPACE,TOK_NAME,TOK_DOT,TOK_INTEGER,TOK_OP_IFTHEN,TOK_OP_ELSE,
					       TOK_OP_LOG_OR,TOK_OP_LOG_AND,TOK_OP_LOG_XOR,TOK_OP_LOG_NOT,
					       TOK_OP_BIN_OR,TOK_OP_BIN_AND,TOK_OP_BIN_XOR,TOK_OP_BIN_NOT,
					       TOK_OP_SHIFT_LEFT,TOK_OP_SHIFT_RIGHT,
					       TOK_OP_EQU,TOK_OP_NEQ,TOK_OP_LT,TOK_OP_GT,TOK_OP_LE,TOK_OP_GE,TOK_OP_CMP,
					       TOK_OP_ADD,TOK_OP_SUB,TOK_OP_MUL,TOK_OP_DIV,TOK_OP_MOD,TOK_OP_POW,
					       TOK_PAREN_OPEN,TOK_PAREN_CLOSE,TOK_COMMA);
    if (result.type == TOK_PC_FAIL)
    {
      list_free(list);
      return result;
    }
    if (result.type == TOK_PC_FAIL1)
    {
      result.type = TOK_LIST;
      result.value.t_struct_list_t_p = list;
      return result;
    }
    list_add_end(list, result);
  }
}
static inline 
struct token_t arguments_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_1(input,token);
}

static inline struct token_t pc_parser_2(struct feeder_t *input, struct token_t *token,int type1,int type2,int type3,int type4,int type5,int type6,int type7,int type8,int type9,int type10,int type11,int type12,int type13,int type14,int type15,int type16,int type17,int type18,int type19,int type20,int type21,int type22,int type23,int type24,int type25,int type26,int type27,int type28,int type29,int type30,int type31)
{
  struct token_t result;
  if ((token->type == type1)||(token->type == type2)||(token->type == type3)||(token->type == type4)||(token->type == type5)||(token->type == type6)||(token->type == type7)||(token->type == type8)||(token->type == type9)||(token->type == type10)||(token->type == type11)||(token->type == type12)||(token->type == type13)||(token->type == type14)||(token->type == type15)||(token->type == type16)||(token->type == type17)||(token->type == type18)||(token->type == type19)||(token->type == type20)||(token->type == type21)||(token->type == type22)||(token->type == type23)||(token->type == type24)||(token->type == type25)||(token->type == type26)||(token->type == type27)||(token->type == type28)||(token->type == type29)||(token->type == type30)||(token->type == type31))
  {
    result = *token;
    *token = feeder_get(input);
  }
  else
    result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_3(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  struct list_t *list;
  list = list_new();
  while (1)
  {
    result = pc_parser_2(input,token,TOK_SPACE,TOK_NAME,TOK_DOT,TOK_INTEGER,TOK_OP_IFTHEN,TOK_OP_ELSE,
					    TOK_OP_LOG_OR,TOK_OP_LOG_AND,TOK_OP_LOG_XOR,TOK_OP_LOG_NOT,
					    TOK_OP_BIN_OR,TOK_OP_BIN_AND,TOK_OP_BIN_XOR,TOK_OP_BIN_NOT,
					    TOK_OP_SHIFT_LEFT,TOK_OP_SHIFT_RIGHT,
					    TOK_OP_EQU,TOK_OP_NEQ,TOK_OP_LT,TOK_OP_GT,TOK_OP_LE,TOK_OP_GE,TOK_OP_CMP,
					    TOK_OP_ADD,TOK_OP_SUB,TOK_OP_MUL,TOK_OP_DIV,TOK_OP_MOD,TOK_OP_POW,
					    TOK_PAREN_OPEN,TOK_PAREN_CLOSE);
    if (result.type == TOK_PC_FAIL)
    {
      list_free(list);
      return result;
    }
    if (result.type == TOK_PC_FAIL1)
    {
      result.type = TOK_LIST;
      result.value.t_struct_list_t_p = list;
      return result;
    }
    list_add_end(list, result);
  }
}
static inline 
struct token_t expr_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_3(input,token);
}

static inline struct token_t pc_parser_4(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_5(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_6(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct expr_t *expr;
    struct token_t result;
    int count;
    struct expr_alloc_t *alloc = NULL;
      pc_retval=pc_parser_4(input,token,TOK_SQUARE_OPEN);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
expr = parse_expr(input, token, &alloc);
      pc_retval=pc_parser_5(input,token,TOK_SQUARE_CLOSE);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
count = expr_calculate(expr);
    expr_alloc_free(alloc);
      result=expr_p(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      result.type = TOK_PC_FAIL;
    return result;
  }
  pc_called = 1;
pc_retval.type = TOK_MULT_LIST;
    pc_retval.value.t_struct_mult_list_t.mult = count;
    pc_retval.value.t_struct_mult_list_t.list = result.value.t_struct_list_t_p;
    return pc_retval;
  
}
static inline 
struct token_t exprs_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_6(input,token);
}

static inline struct token_t pc_parser_7(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_8(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_9(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_10(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  result=pc_parser_9(input,token,TOK_STRING);
  if (result.type != TOK_PC_FAIL1)
    return result;  result=exprs_p(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;  result=expr_p(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;
  return result;
}

static inline struct token_t pc_parser_11(struct feeder_t *input, struct token_t *token)
{
  struct token_t result, retval;
  result = pc_parser_7(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
    return result;
  retval = pc_parser_10(input,token);
  if ((retval.type == TOK_PC_FAIL)||(retval.type == TOK_PC_FAIL1))
  {
    retval.type = TOK_PC_FAIL;
    return retval;
  }
  result = pc_parser_8(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
  {
    result.type = TOK_PC_FAIL;
    return result;
  }
  return retval;
}

static inline struct token_t pc_parser_12(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_13(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  struct list_t *list;
  list = list_new();
  result = pc_parser_11(input,token);
  if (result.type == TOK_PC_FAIL)
  {
    list_free(list);
    return result;
  }
  if (result.type == TOK_PC_FAIL1)
  {
    result.type = TOK_LIST;
    result.value.t_struct_list_t_p = list;
    return result;
  }
  list_add_end(list, result);
  while (1)
  {
    result = pc_parser_12(input,token,TOK_COMMA);
    if (result.type == TOK_PC_FAIL)
    {
      list_free(list);
      return result;
    }
    if (result.type == TOK_PC_FAIL1)
    {
      result.type = TOK_LIST;
      result.value.t_struct_list_t_p = list;
      return result;
    }
    result = pc_parser_11(input,token);
    if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
    {
      result.type = TOK_PC_FAIL;
      list_free(list);
      return result;
    }
    list_add_end(list,result);
  }
}

static inline struct token_t pc_parser_14(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t arg, t;
    char *string;
    struct list_t *alist;
    int i;

      arg=pc_parser_13(input,token);
  if ((arg.type == TOK_PC_FAIL)||(arg.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      arg.type = TOK_PC_FAIL;
    return arg;
  }
  pc_called = 1;
alist = arg.value.t_struct_list_t_p;
    arg.type = TOK_BEGIN_INSTR;
    stream_put(output, arg);
    for (arg = list_get_begin(alist); arg.type != TOK_LIST_END; arg = list_get_begin(alist))
    {
      if (arg.type == TOK_STRING)
	{
	  arg.type = TOK_BYTE_INT;
	  for (string = arg.value.t_char_p; *string; string++)
	    {
	      if (*string == '\\')
		{
		  string++;
		  if (*string == '0')
		    arg.value.t_int = 0;
		  else
		    arg.value.t_int = *string;
		}
	      else
		arg.value.t_int = *string;
	      stream_put(output, arg);
	    }
	}
      else if (arg.type == TOK_MULT_LIST)
	{
	  t.type = TOK_BYTE;
	  t.position = arg.position;
	  for (i = 0; i < arg.value.t_struct_mult_list_t.mult; i++)
	    {
	      stream_put(output, t);
	      list_inc_refcount(arg.value.t_struct_mult_list_t.list);
	      list_add_list_end(&(output->list), arg.value.t_struct_mult_list_t.list);
	    }
	  list_dec_refcount(arg.value.t_struct_mult_list_t.list);
	  list_free(arg.value.t_struct_mult_list_t.list);
	}
      else if (arg.type == TOK_LIST)
	{
	  t.type = TOK_BYTE;
	  t.position = arg.position;
	  stream_put(output, t);
	  list_add_list_end(&(output->list), arg.value.t_struct_list_t_p);
	  list_free(arg.value.t_struct_list_t_p);
	}
      else
	ERROR("internal error\n");
    }
    list_free(alist);
      pc_retval=end_of_line_p(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
arg.type = TOK_PC_SUCCESS;
    return arg;
  
}
static inline 
struct token_t db_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_14(input,token);
}

static inline struct token_t pc_parser_15(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_16(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_17(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  result=exprs_p(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;  result=expr_p(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;
  return result;
}

static inline struct token_t pc_parser_18(struct feeder_t *input, struct token_t *token)
{
  struct token_t result, retval;
  result = pc_parser_15(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
    return result;
  retval = pc_parser_17(input,token);
  if ((retval.type == TOK_PC_FAIL)||(retval.type == TOK_PC_FAIL1))
  {
    retval.type = TOK_PC_FAIL;
    return retval;
  }
  result = pc_parser_16(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
  {
    result.type = TOK_PC_FAIL;
    return result;
  }
  return retval;
}

static inline struct token_t pc_parser_19(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_20(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  struct list_t *list;
  list = list_new();
  result = pc_parser_18(input,token);
  if (result.type == TOK_PC_FAIL)
  {
    list_free(list);
    return result;
  }
  if (result.type == TOK_PC_FAIL1)
  {
    result.type = TOK_LIST;
    result.value.t_struct_list_t_p = list;
    return result;
  }
  list_add_end(list, result);
  while (1)
  {
    result = pc_parser_19(input,token,TOK_COMMA);
    if (result.type == TOK_PC_FAIL)
    {
      list_free(list);
      return result;
    }
    if (result.type == TOK_PC_FAIL1)
    {
      result.type = TOK_LIST;
      result.value.t_struct_list_t_p = list;
      return result;
    }
    result = pc_parser_18(input,token);
    if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
    {
      result.type = TOK_PC_FAIL;
      list_free(list);
      return result;
    }
    list_add_end(list,result);
  }
}

static inline struct token_t pc_parser_21(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t arg, t;
    struct list_t *alist;
    int i;
      arg=pc_parser_20(input,token);
  if ((arg.type == TOK_PC_FAIL)||(arg.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      arg.type = TOK_PC_FAIL;
    return arg;
  }
  pc_called = 1;
alist = arg.value.t_struct_list_t_p;
    arg.type = TOK_BEGIN_INSTR;
    stream_put(output, arg);
    for (arg = list_get_begin(alist); arg.type != TOK_LIST_END; arg = list_get_begin(alist))
    {
      if (arg.type == TOK_LIST)
	{
	  t.type = TOK_WORD;
	  t.position = arg.position;
	  stream_put(output, t);
	  list_add_list_end(&(output->list), arg.value.t_struct_list_t_p);
	  list_free(arg.value.t_struct_list_t_p);
	}
      else if (arg.type == TOK_MULT_LIST)
	{
	  t.type = TOK_WORD;
	  t.position = arg.position;
	  for (i = 0; i < arg.value.t_struct_mult_list_t.mult; i++)
	    {
	      stream_put(output, t);
	      list_inc_refcount(arg.value.t_struct_mult_list_t.list);
	      list_add_list_end(&(output->list), arg.value.t_struct_mult_list_t.list);
	    }
	  list_dec_refcount(arg.value.t_struct_mult_list_t.list);
	  list_free(arg.value.t_struct_mult_list_t.list);
	}
      else
	ERROR("internal error\n");
    }
    list_free(alist);
      pc_retval=end_of_line_p(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
arg.type = TOK_PC_SUCCESS;
    return arg;
  
}
static inline 
struct token_t dw_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_21(input,token);
}

static inline struct token_t pc_parser_22(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_23(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_24(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  result=exprs_p(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;  result=expr_p(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;
  return result;
}

static inline struct token_t pc_parser_25(struct feeder_t *input, struct token_t *token)
{
  struct token_t result, retval;
  result = pc_parser_22(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
    return result;
  retval = pc_parser_24(input,token);
  if ((retval.type == TOK_PC_FAIL)||(retval.type == TOK_PC_FAIL1))
  {
    retval.type = TOK_PC_FAIL;
    return retval;
  }
  result = pc_parser_23(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
  {
    result.type = TOK_PC_FAIL;
    return result;
  }
  return retval;
}

static inline struct token_t pc_parser_26(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_27(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  struct list_t *list;
  list = list_new();
  result = pc_parser_25(input,token);
  if (result.type == TOK_PC_FAIL)
  {
    list_free(list);
    return result;
  }
  if (result.type == TOK_PC_FAIL1)
  {
    result.type = TOK_LIST;
    result.value.t_struct_list_t_p = list;
    return result;
  }
  list_add_end(list, result);
  while (1)
  {
    result = pc_parser_26(input,token,TOK_COMMA);
    if (result.type == TOK_PC_FAIL)
    {
      list_free(list);
      return result;
    }
    if (result.type == TOK_PC_FAIL1)
    {
      result.type = TOK_LIST;
      result.value.t_struct_list_t_p = list;
      return result;
    }
    result = pc_parser_25(input,token);
    if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
    {
      result.type = TOK_PC_FAIL;
      list_free(list);
      return result;
    }
    list_add_end(list,result);
  }
}

static inline struct token_t pc_parser_28(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t arg, t;
    struct list_t *alist;
    int i;
      arg=pc_parser_27(input,token);
  if ((arg.type == TOK_PC_FAIL)||(arg.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      arg.type = TOK_PC_FAIL;
    return arg;
  }
  pc_called = 1;
alist = arg.value.t_struct_list_t_p;
    arg.type = TOK_BEGIN_INSTR;
    stream_put(output, arg);
    for (arg = list_get_begin(alist); arg.type != TOK_LIST_END; arg = list_get_begin(alist))
    {
      if (arg.type == TOK_LIST)
	{
	  t.type = TOK_DWORD;
	  t.position = arg.position;
	  stream_put(output, t);
	  list_add_list_end(&(output->list), arg.value.t_struct_list_t_p);
	  list_free(arg.value.t_struct_list_t_p);
	}
      else if (arg.type == TOK_MULT_LIST)
	{
	  t.type = TOK_DWORD;
	  t.position = arg.position;
	  for (i = 0; i < arg.value.t_struct_mult_list_t.mult; i++)
	    {
	      stream_put(output, t);
	      list_inc_refcount(arg.value.t_struct_mult_list_t.list);
	      list_add_list_end(&(output->list), arg.value.t_struct_mult_list_t.list);
	    }
	  list_dec_refcount(arg.value.t_struct_mult_list_t.list);
	  list_free(arg.value.t_struct_mult_list_t.list);
	}
      else
	ERROR("internal error\n");
    }
    list_free(alist);
      pc_retval=end_of_line_p(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
arg.type = TOK_PC_SUCCESS;
    return arg;
  
}
static inline 
struct token_t dd_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_28(input,token);
}

static inline struct token_t pc_parser_29(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    while (token->type != TOK_NEWLINE)
    {
      if (token->type == TOK_END_OF_FILE)
      {
	pc_retval.type = TOK_PC_SUCCESS;
	return pc_retval;
      }
      stream_put(output, *token);
      *token = feeder_get(input);
    }
    stream_put(output, *token);
    *token = feeder_get(input);
    pc_retval.type = TOK_PC_SUCCESS;
    return pc_retval;
  
}
static inline 
struct token_t copy_line_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_29(input,token);
}

static inline struct token_t pc_parser_30(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (token->type == TOK_SPACE)
    *token = feeder_get(input);
  result.type = TOK_PC_SUCCESS;
  return result;
}

static inline struct token_t pc_parser_31(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  switch (token->type)
  {
  case TOK_DB:
    *token = feeder_get(input);
    result = db_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
			      TOK_DW:
    *token = feeder_get(input);
    result = dw_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
			      TOK_DD:
    *token = feeder_get(input);
    result = dd_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  default:
    result.type = TOK_PC_FAIL1;
    return result;
  }
}

static inline struct token_t pc_parser_32(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  result=pc_parser_31(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;  result=opcode_p(input,token,asmb->proc);
  if (result.type != TOK_PC_FAIL1)
    return result;  result=copy_line_p(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;
  return result;
}

static inline struct token_t pc_parser_33(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;
  pc_retval=pc_parser_30(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  pc_retval=pc_parser_32(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
return pc_retval;

}
static inline 
struct token_t asm_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_33(input,token);
}

static inline struct token_t pc_parser_34(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  switch (token->type)
  {
  case TOK_DB:
    *token = feeder_get(input);
    result = db_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
					      TOK_DW:
    *token = feeder_get(input);
    result = dw_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
					      TOK_DD:
    *token = feeder_get(input);
    result = dd_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  case 
					      TOK_SPACE:
    *token = feeder_get(input);
    result = asm_p(input,token);
    if (result.type == TOK_PC_FAIL1)
      result.type = TOK_PC_FAIL;
    return result;
  default:
    result.type = TOK_PC_FAIL1;
    return result;
  }
}

static inline struct token_t pc_parser_35(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  result=pc_parser_34(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;  result=copy_line_p(input,token);
  if (result.type != TOK_PC_FAIL1)
    return result;
  return result;
}
static inline 
struct token_t assembler_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_35(input,token);
}


static inline struct token_t end_of_line_p(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;

  if (token->type == TOK_NEWLINE)
    {
      stream_put(output, *token);
      *token = feeder_get(input);
      result.type = TOK_PC_SUCCESS;
      return result;
    }
  else if (token->type == TOK_END_OF_FILE)
    {
      result.type = TOK_PC_SUCCESS;
      return result;
    }
  else
    {
      result.type = TOK_PC_FAIL1;
      return result;
    }
}













static inline struct token_t opcode_p(struct feeder_t *input, struct token_t *token, struct processor_t *codes)
{
  struct token_t result,t;
  struct proc_instr_t *code;
  struct proc_instr_arg_t *arg;
  struct list_t *args;

  if (token->type != TOK_NAME)
  {
    result.type = TOK_PC_FAIL1;
    return result;
  }
  
  if (!(code = processor_get_instr(codes, token->value.t_char_p)))
  {
    result.type = TOK_PC_FAIL1;
    return result;
  }
  *token = feeder_get(input);
  
  result = arguments_p(input,token);

  arg = proc_instr_get_arg(code, result.value.t_struct_list_t_p);
  if (!arg)
    {
      result.type = TOK_PC_FAIL;
      return result;
    }
  args = proc_instr_arg_get_pattern(arg->pattern, result.value.t_struct_list_t_p);
  t.type = TOK_BEGIN_INSTR;
  stream_put(output, t);
  foreach (result, arg->data)
    if (result.type == TOK_ARG)
      {
	t = list_read_index(args,result.value.t_int);
	list_add_list_end(&(output->list), t.value.t_struct_list_t_p);
      }
    else
      stream_put(output,token_copy(result));

  if (token->type == TOK_NEWLINE)
    {
      stream_put(output, *token);
      *token = feeder_get(input);
    }
  else if (token->type != TOK_END_OF_FILE)
    {
      result.type = TOK_PC_FAIL;
      return result;
    }

  result.type = TOK_PC_SUCCESS;
  return result;
}







/*
__INLINE_PARSER assembler_p =
  pc_or(pc_switch(TOK_DB, db_p,
		  TOK_DW, dw_p,
		  TOK_DD, dd_p),
	opcode_p(asmb->proc),
      {stream_put(output, *token); *token = feeder_get(input); pc_retval.type = TOK_PC_SUCCESS; return pc_retval;});
*/

void assembler_execute(struct feeder_t *input, struct stream_t *output_s, struct assembler_t *assembler)
{
  struct token_t result;
  int i = 0;

  output = output_s;
  asmb = assembler;
  if (assembler->look_ahead.type == TOKENS_COUNT)
    assembler->look_ahead = feeder_get(input);
  for (i = 0; i < 16; i++)
    {
      if (assembler->look_ahead.type == TOK_END_OF_FILE)
	break;
      result = assembler_p(input, &(assembler->look_ahead));
      if ((result.type == TOK_PC_FAIL) || (result.type == TOK_PC_FAIL1))
	T_ERROR(assembler->look_ahead, "syntax error\n");
      if (result.type != TOK_PC_SUCCESS)
	stream_put(output_s, result);
    }
  if (assembler->look_ahead.type == TOK_END_OF_FILE)
    {
      stream_put(output_s, assembler->look_ahead);
      assembler_free(assembler);
      feeder_free(input);
    }
}
