#define ZASM_GROW_STRING_C 1

#include <zasm/grow_string.h>
#include <string.h>
#include <zasm/memory.h>

#define GROW_STRING_STEP 256

void grow_string_add(struct grow_string_t *str, char *string)
{
  int l;
  l = strlen(string);
  if (str->length+l >= str->mem_length)
    {
      for (str->mem_length+=GROW_STRING_STEP; str->length+l >= str->mem_length; str->mem_length+=GROW_STRING_STEP);
      REALLOCATE(char, str->string, str->mem_length);
    }
  strcpy(str->string + str->length, string);
  str->length += l;
}

void grow_string_add_char(struct grow_string_t *str, char c)
{
  if (c == 0)
    {
      grow_string_add(str, "\0");
      return;
    }
  if (c == '\\')
    {
      grow_string_add(str, "\\");
      return;
    }
  if (str->length+1 >= str->mem_length)
    {
      str->mem_length+=GROW_STRING_STEP;
      REALLOCATE(char, str->string, str->mem_length);
    }
  str->string[str->length] = c;
  str->length++;  
  str->string[str->length] = 0;
}

void grow_string_reset(struct grow_string_t *str)
{
  str->length = 0;
  if (str->string)
    str->string[0] = 0;
}
