#ifndef ZASM_PP_ENTRY_H
#define ZASM_PP_ENTRY_H 1

#include <zasm/hash_table.h>

#define PP_ENTRY_PT(O) ((struct pp_entry_t **)(O))
#define PP_ENTRY_T(O) ((struct pp_entry_t *)(O))
struct pp_entry_t
{
  struct hash_entry_t entry;
  
  struct pp_macro_t *macro;
};

#include <zasm/alloc.h>
#define PP_ENTRY_ALLOC_T(O) ((struct pp_entry_alloc_t *)(O))
ALLOC_DECLARE(pp_entry, ALLOC_DEF_COUNT);

#include <zasm/pp_macro.h>
#include <zasm/pp_namespace.h>
struct pp_entry_t *pp_entry_new(struct pp_level_t *level, char *name, struct pp_macro_t *macro);
void pp_entry_fill(struct pp_entry_t *entry, struct pp_level_t *level, char *name, struct pp_macro_t *macro);
void pp_entry_redef(struct pp_entry_t *entry, struct pp_macro_t *macro);
void pp_entry_delete(struct pp_entry_t *entry);
void pp_entry_free(struct pp_entry_t *entry);

#endif
